import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;
/**
 * Write a description of class JuniorExerciseTwo here.
 * 
 * @author 
 * @version 
 */
public class JuniorExerciseTwo extends World
{
    /*
     * ge-       +
     * -e        +
     * -st       +
     * -t        +
     * -en       +
     * -te       +
     * -test     +
     * -ten      +    
     * -tet      +
     * -end      +
     */
    public Text texts = new Text();
    /**
     * Initialize the TextField the Text and the Background
     */
    public JuniorExerciseTwo()
    {    
        super(800, 600, 1); 
        texts = new Text();
        addObject(texts,getWidth()/2, getHeight()/3*2);
        setPaintOrder(TextField.class, Background.class);
        TextField tf = new TextField();
        tf.setResponder(this);
        tf.setPrefix("Gebe das Wort ein");
        addObject(tf, getWidth()/2, getHeight() /2);
        GreenfootImage bg = getBackground();
        // for Background
        matrix();
        Greenfoot.start();
    }

    /**
     * The responder of the Text Field
     * @param text the String in the Textfield
     * @param sender the Textfield which responds
     */
    public void textFieldIsDoneWithText(String text, TextField sender)
    {
        texts.rename(giveInfinitive(text));
    }

    /** 
     * returns the infinitive of a given string.
     * @param word The verb given as String
     * @return the infinitive of the String
     */
    public String giveInfinitive(String word)
    {
        try
        {
            String stem = word;
            if(stem.charAt(0) == 'g' && stem.charAt(1) == 'e') // ge-
            {
                stem = stem.substring(2);
            }
            if(stem.charAt(stem.length() - 1) == 't') // -t
            {
                stem = stem.substring(0, stem.length() - 1);
                if(stem.charAt(stem.length() - 1) == 'e' && stem.charAt(stem.length() - 2) == 't') // -tet
                {
                    stem = stem.substring(0, stem.length() - 2);
                }else if(stem.charAt(stem.length() - 1) == 's') // -st
                {
                    stem = stem.substring(0, stem.length() - 1);
                    if(stem.charAt(stem.length() - 1) == 'e' && stem.charAt(stem.length() - 2) == 't') // -test
                    {
                        stem = stem.substring(0, stem.length() - 2);
                    }
                }
            } else if(stem.charAt(stem.length() - 1) == 'e') // -e
            {
                stem = stem.substring(0,stem.length() - 1);
                if(stem.charAt(stem.length() - 1) == 't') // -et
                {
                    stem = stem.substring(0, stem.length() -1);
                    if(stem.charAt(stem.length() - 1) == 'e') // -ete
                    {
                        stem = stem.substring(0, stem.length() -1);
                    }
                }
            } else if(stem.charAt(stem.length() - 1) == 'n' && stem.charAt(stem.length() - 2) == 'e') // -en
            {
                stem = stem.substring(0,stem.length() - 2);
                if(stem.charAt(stem.length() - 1) == 't') // -ten
                {
                    stem=stem.substring(0,stem.length() - 1);
                }
            } else if(stem.charAt(stem.length() - 1) == 'd' && stem.charAt(stem.length() - 2) == 'n' && stem.charAt(stem.length() - 3) == 'e') // -end
            {
                stem = stem.substring(0, stem.length() - 3);
            }
            String infinitive = stem + "en";
            if(infinitive != "en")
            {
                return infinitive;
            }else
            {
                return "too short";
            }
        } catch(java.lang.StringIndexOutOfBoundsException ex)
        {
            return "too short";
        }
    }

    public void act()
    {
        actMatrix();
    }

    // Background only
    /** The colour used to colourize the background **/
    private static Color WORLD_COLOUR = Color.BLACK;

    /** This is the colour used for the code objects **/
    public static Color CODE_COLOUR = Color.GREEN;

    /** The time between each line of code is generated **/
    public static long TIME = 100;

    /** Store when the last action was held **/
    private long LAST_ACTION = System.currentTimeMillis();

    /** The time in milli seconds when the garbage collector must run */
    private long GC_TIME = 60000 * 2; //every two minutes

    /** The last time the garbage collector has run manually */
    private long LAST_GC_MOMENT = System.currentTimeMillis();

    /**
     * initialize the matrix background
     */
    private void matrix()
    {
        colourize();
        append();
        System.gc();
    }

    /**
     * Append the code onto the world
     */
    public void append()
    {
        Background c = new Background(CODE_COLOUR, true);
        addObject(c, 15 * (int)(Math.random() * getWidth() / 15), 5);
    }

    /**
     * Append some colour to the world
     */
    public void colourize()
    {
        getBackground().setColor(WORLD_COLOUR);
        getBackground().fill();
    }

    /**
     * The act Method for the Matrix
     */
    public void actMatrix()
    {
        if(System.currentTimeMillis() - LAST_ACTION > TIME) {
            append();
            LAST_ACTION = System.currentTimeMillis();
        }
        if (System.currentTimeMillis() - LAST_GC_MOMENT >= GC_TIME) {
            System.gc();
            LAST_GC_MOMENT = System.currentTimeMillis();
        }
    }
}